// SONIX Cite

// https://developer.mozilla.org/en-US/Add-ons/SDK/Tools/jpm
// jpm init   jpm run   jpm xpi

// https://developer.mozilla.org/en-US/Add-ons/SDK/Tutorials/Display_a_Popup
// https://developer.mozilla.org/en-US/Add-ons/SDK/High-Level_APIs/panel
// https://developer.mozilla.org/en-US/Add-ons/SDK/Tutorials/Modifying_the_Page_Hosted_by_a_Tab

// https://developer.mozilla.org/en-US/Add-ons/SDK/Tutorials/Listen_for_Page_Load
// https://developer.mozilla.org/en-US/Add-ons/Code_snippets/On_page_load
// https://developer.mozilla.org/en-US/Add-ons/SDK/High-Level_APIs/page-mod

// http://rominirani.com/2013/08/01/firefox-os-tutorial-episode-6-enabling-storage/
// http://www.w3schools.com/HTML/html5_webstorage.asp

// http://stackoverflow.com/questions/9749127/closing-a-panel-from-iframe-in-firefox-add-ons
// http://stackoverflow.com/questions/16369642/javascript-how-to-use-a-regular-expression-to-remove-blank-lines-from-a-string
// /^\s*[\r\n]/gm    \s - space  g - global modifier  m - multiline modifier
// ^\s - match with space in beginning of line, requires multiline
// \s* - match many spaces, until other character
// [\r\n] - match \r\n or \r or \n (all line terminators)

// Init
var self = require('sdk/self');
var tabs = require("sdk/tabs");
var buttons = require('sdk/ui/button/action');

// Create button for uploading
var bUpload = buttons.ActionButton({
  id: "sonix-upload",
  label: "Upload citations on SONIX",
  icon: {
    "16": "./upload-16.png",
    "32": "./upload-32.png",
    "64": "./upload-64.png"
  },
  onClick: function () {
    tabs.activeTab.attach({
      contentScriptFile: self.data.url("upload.js")
    });
  }
});

// Create button for deleting
var bDelete = buttons.ActionButton({
  id: "sonix-delete",
  label: "Delete citations on SONIX",
  icon: {
    "16": "./delete-16.png",
    "32": "./delete-32.png",
    "64": "./delete-64.png"
  },
  onClick: function () {
    tabs.activeTab.attach({
      contentScriptFile: self.data.url("delete.js")
    });
  }
});

// Attach controller to each tab after the page is ready
// Activates for uploading on sonix.bas.bg/bg/264/
// Activates for deleting on sonix.bas.bg/bg/242/
// This is the actual upload/delete script
require("sdk/tabs").on("ready", runScript);
function runScript(tab) {
  tab.attach({
    contentScriptFile: "control.js"
  });
}

